/*************************************************************/
/**                                                         **/
/**                 common.h Unix/X drivers                 **/
/**                                                         **/
/**                  (C) James McKay 1996                   **/
/**                                                         **/
/**             This software may not be used               **/
/**             for commercial reasons, the code            **/
/**             may not be modified or reused               **/
/**             without permission.                         **/
/**                                                         **/
/**---------------------------------------------------------**/
/** Adaptions for any X-terminal by Arnold Metselaar.       **/
/**     If you want to use this file for VGA, you will need **/
/**     to adapt MSDOS.c . Please, notify me as well, if    **/
/**     you make any changes to this file.                  **/
/*************************************************************/

#ifdef SCALE2
void expand_long(unsigned long input,unsigned long *out0,unsigned long *out1)
{
	quadruple qtemp, otemp0, otemp1;

	qtemp.Q=input;
#ifdef LSB_FIRST
	otemp0.B.b1=qtemp.B.b1;
	otemp0.B.b2=qtemp.B.b1;
	otemp0.B.b3=qtemp.B.b2;
	otemp0.B.b4=qtemp.B.b2;
	otemp1.B.b1=qtemp.B.b3;
	otemp1.B.b2=qtemp.B.b3;
	otemp1.B.b3=qtemp.B.b4;
	otemp1.B.b4=qtemp.B.b4;
#else
	otemp1.B.b1=qtemp.B.b1;
	otemp1.B.b2=qtemp.B.b1;
	otemp1.B.b3=qtemp.B.b2;
	otemp1.B.b4=qtemp.B.b2;
	otemp0.B.b1=qtemp.B.b3;
	otemp0.B.b2=qtemp.B.b3;
	otemp0.B.b3=qtemp.B.b4;
	otemp0.B.b4=qtemp.B.b4;
#endif
	*out0=otemp0.Q;
	*out1=otemp1.Q;
}

void update_8bitline(register UC linenum)
{
	register word calccy, bitmap, colmap, bitmap2, colmap2, line_w;
	UC x, colr, attr, data, Xborder;
	unsigned long *R;

	bitmap2=bitmap=spline[linenum];
	colmap2=colmap=6144|((linenum>>3)<<5);
	line_w=linenum<<1;
	R=XBuf8+(WIDTHR2*line_w);

	Xborder=XPal[border];
	memset(R,Xborder,64);
	R+=16;

	x=32;
	do
	{
		colr=SP_SCREEN[colmap++];
		attr=colr&127;
		if ((flash_status)&&(colr>>7))
		{
			attr=reverse_attr[attr];
		}
		data=SP_SCREEN[bitmap++];
		*R++=vga_h_nib0[data>>4][attr];
		*R++=vga_h_nib1[data>>4][attr];
		*R++=vga_h_nib0[data&0x0F][attr];
		*R++=vga_h_nib1[data&0x0F][attr];
	} while (--x);

	memset(R,Xborder,64);
	R+=16;

/* Second Line */

	memset(R,Xborder,64);
	R+=16;

	x=32;
	do
	{
		colr=SP_SCREEN[colmap2++];
		attr=colr&127;
		if ((flash_status)&&(colr>>7))
		{
			attr=reverse_attr[attr];
		}
		data=SP_SCREEN[bitmap2++];
		*R++=vga_h_nib0[data>>4][attr];
		*R++=vga_h_nib1[data>>4][attr];
		*R++=vga_h_nib0[data&0x0F][attr];
		*R++=vga_h_nib1[data&0x0F][attr];
	} while (--x);

	memset(R,Xborder,64);

}
#else
void update_8bitline(register UC linenum)
{
	register word calccy, bitmap, colmap;
	UC x, colr, attr, data, Xborder;
	unsigned long *R;

	bitmap=spline[linenum];
	colmap=6144|((linenum>>3)<<5);

	R=XBuf8+WIDTHR2*linenum;

	Xborder=XPal[border];
	memset(R,Xborder,32);
	R+=8;

	x=32;
	do
	{
		colr=SP_SCREEN[colmap++];
		attr=colr&127;
		if ((flash_status)&&(colr>>7))
		{
			attr=reverse_attr[attr];
		}
		data=SP_SCREEN[bitmap++];
		*R++=vga_h_nib[data>>4][attr];
		*R++=vga_h_nib[data&0x0F][attr];
	} while (--x);

	memset(R,Xborder,32);

}
#endif

#ifdef SCALE2
void update_monoline(register UC linenum)
{
	register word calccy, bitmap, colmap, bitmap2, colmap2, line_w;
	UC x, colr, data, m_bord;
	UC *M;

	bitmap2=bitmap=spline[linenum];
	colmap2=colmap=6144|((linenum>>3)<<5);
	line_w=linenum<<1;
	M=XBuf+(WIDTHR3*line_w);

	m_bord=mono0[0][border<<3];
	memset(M,m_bord,8);
	M+=8;
	/**M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;
	*M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;*/

	x=32;
	do
	{
		colr=SP_SCREEN[colmap++];
		data=SP_SCREEN[bitmap++];
		if ((flash_status)&&(colr>>7))
		{
			data=~data;
		}
		*M++=mono0[data][colr&63];
		*M++=mono1[data][colr&63];
	} while (--x);

	memset(M,m_bord,8);
	M+=8;
	/**M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;
	*M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;*/

/* Second Line */

	memset(M,m_bord,8);
	M+=8;
	/**M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;
	*M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;*/

	x=32;
	do
	{
		colr=SP_SCREEN[colmap2++];
		data=SP_SCREEN[bitmap2++];
		if ((flash_status)&&(colr>>7))
		{
			data=~data;
		}
		*M++=mono0[data][colr&63];
		*M++=mono1[data][colr&63];
	} while (--x);

	memset(M,m_bord,8);
	/**M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;
	*M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;*/

}
#else
void update_monoline(register UC linenum)
{
	register word calccy, bitmap, colmap;
	UC x, colr, data, m_bord;
	UC *M;

	bitmap=spline[linenum];
	colmap=6144|((linenum>>3)<<5);

	M=XBuf+WIDTHR3*linenum;

	m_bord=mono[0][border<<3];
	memset(M,m_bord,4);
	M+=4;
	/**M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;*/

	x=32;
	do
	{
		colr=SP_SCREEN[colmap++];
		data=SP_SCREEN[bitmap++];
		if ((flash_status)&&(colr>>7))
		{
			data=~data;
		}
		*M++=mono[data][colr&63];
	} while (--x);

	memset(M,m_bord,4);
	/**M++=m_bord;*M++=m_bord;*M++=m_bord;*M++=m_bord;*/

}
#endif
/****************************************************************/
/*** Display the screen buffer.                               ***/
/****************************************************************/
void RefreshScreen() { PutImage(); }
